	
	integer FP_VAR, MAX_ORDER, TARG_VAR 
	parameter (FP_VAR    = 5)		! # of focal plane variables
	parameter (TARG_VAR  = 5)		! # of target variables
	parameter (MAX_ORDER = 7)		! # of orders to consider

	structure /element/			! Individual matrix element
	  real*8 value				! value
	  real*8 error				! uncertianty
	  real*8 lower				! lower limit
	  real*8 upper				! upper limit
	  logical set				! if this element was set
	  logical modified			! if this element was modified
	  logical vary				! allow to vary in the fit
	end structure				! element

	structure /fp_ofp/		! physical to optical dp
	  record /element/ x_det 	! offset of det from central traj (cm)
	  record /element/ y_det 	! offset of det from central traj (cm)
	  record /element/ theta_det 	! rotation of det from mag traj (deg)
	  record /element/ z		! translation along central traj (cm)
	  record /element/ theta	! rot angle from fp to ofp about y (deg)
	  record /element/ phi		! rot angle from fp to ofp about x'(deg)
	  record /element/ ang_slope_x	! change in the central angle along x
	  record /element/ ang_slope_y	! change in the central angle along y
	  record /element/ ang_offset_x	! offset of x' angle (mr)
	  record /element/ ang_offset_y	! offset of y' angle (mr)
	  real*8 cos_theta_det 		! cosine of theta_det
	  real*8 sin_theta_det 		! tangent of theta_det
	  real*8 cos_theta		! cosine of theta
	  real*8 tan_theta		! tangent of theta
	  real*8 cos_phi		! cosine of phi
	  real*8 tan_phi		! tangent of phi
	endstructure			! fp_ofp

	structure /ofp_targ/		! matrix elements
	  record /element/ me0			! zeroth order elements
	  record /element/ me1(FP_VAR)		! first order elements
	  record /element/ me2(FP_VAR, FP_VAR)	! second order elements
	  record /element/ me3(FP_VAR, FP_VAR, FP_VAR)	! third order elements
	  record /element/ me4(FP_VAR, FP_VAR, FP_VAR, FP_VAR)	
	  record /element/ me5(FP_VAR, FP_VAR, FP_VAR, FP_VAR, FP_VAR)
	  record /element/ me6(FP_VAR, FP_VAR, FP_VAR, FP_VAR, FP_VAR, FP_VAR)
	end structure				! ofp_targ


	structure /targ_slit/			! target to slit
	  record /element/ drift		! drift distance (m)
	endstructure

	record /fp_ofp/ fp_ofp			! xform from fp to ofp
	record /ofp_targ/ ofp_targ(TARG_VAR)	! xform from ofp to targ 
	record /targ_slit/ targ_slit		! xform from targ to slits
	logical me_init_flag			! initialization flag
	
	common /matrix_elements/ fp_ofp, ofp_targ, targ_slit, me_init_flag
c
	character*3 spec_name
	common / pass_spec_name / spec_name
c