	subroutine me_db_read_parse (line, line_number)

	implicit none

	include 'db.inc'

	character*(*) line			! line buffer
	integer line_number			! line # into file

	integer final_index			! index of final variable
	record /element/ me			! ME values
	integer i				! index element
	integer order				! order of initial ME
	integer indices(MAX_ORDER)		! variable indices

	integer lnblnk				! last non-blank char

	do i = 1, len(line)			! first change tabs to blanks
	 if (line(i:i) .eq. '	') then
	   line(i:i) = ' '
	  endif
	enddo

* Now try and parse the line

	if (line(1:1) .ne. '<') return		! not a matrix element line
	call me_parse_name(line,final_index,order,indices,line_number)
	if (order .eq. -1) return

	read (line(index(line,'>')+1:lnblnk(line)), *, err=1000,end=1000)
     >          me.value, me.error, me.lower, me.upper
	  
*
* Now store the values we have read into the proper location
*
	call me_db_replace(ofp_targ(final_index), me, 
     >                     line_number, order, indices)

	return

1000	continue
	write (*,*) ' Error while parsing line number ', line_number
	write (*,*) line
	end
