	subroutine me_db_replace (var, me, line, order, index)
*
* This routine will replace a matrix element with the new one
*
* var is matrix element structure to use
* me is the values to use
* line is the line number in the file
* index is an array of the initial variable indices
*
* 21-May-94, Pat Welch, Oregon State University (tpw@physics.orst.edu)
* 30-Jan-95, TPW modified to use me_db_replace and orders<-1
*
	implicit none

	include 'db.inc'

	record /ofp_targ/ var
	record /element/ me
	integer line, index(MAX_ORDER), order

	integer i1, i2, i3, i4, i5, i6

	i1 = index(1)
	i2 = index(2)
	i3 = index(3)
	i4 = index(4)
	i5 = index(5)
	i6 = index(6)

	if (order .eq. -2) then
	  call me_db_replace_set(fp_ofp.x_det, me)
	else if (order .eq. -3) then
	  call me_db_replace_set(fp_ofp.y_det, me)
	else if (order .eq. -4) then
	  call me_db_replace_set(fp_ofp.theta_det, me)
	else if (order .eq. -5) then
	  call me_db_replace_set(fp_ofp.z, me)
	else if (order .eq. -6) then
	  call me_db_replace_set(fp_ofp.theta, me)
	else if (order .eq. -7) then
	  call me_db_replace_set(fp_ofp.phi, me)
	else if (order .eq. -8) then
	  call me_db_replace_set(targ_slit.drift, me)
	else if (order .eq. -9) then
	  call me_db_replace_set(fp_ofp.ang_slope_x, me)
	else if (order .eq. -10) then
	  call me_db_replace_set(fp_ofp.ang_slope_y, me)
	else if (order .eq. -11) then
	  call me_db_replace_set(fp_ofp.ang_offset_x, me)
	else if (order .eq. -12) then
	  call me_db_replace_set(fp_ofp.ang_offset_y, me)
	else if (order .eq. 0) then
	  call me_db_replace_set(var.me0, me)
	else if (order .eq. 1) then
	  call me_db_replace_set(var.me1(i1), me)
	else if (order .eq. 2) then
	  call me_db_replace_set(var.me2(i1,i2), me)
	else if (order .eq. 3) then
	  call me_db_replace_set(var.me3(i1,i2,i3), me)
	else if (order .eq. 4) then
	  call me_db_replace_set(var.me4(i1,i2,i3,i4), me)
	else if (order .eq. 5) then
	  call me_db_replace_set(var.me5(i1,i2,i3,i4,i5), me)
	else if (order .eq. 6) then
	  call me_db_replace_set(var.me6(i1,i2,i3,i4,i5,i6), me)
	else
	  write (*,*) ' Matrix element order too large, ', order
	  write (*,*) ' in line # ', line
	endif

	return
	end

	subroutine me_db_replace_set (var, me)

	implicit none

	include 'db.inc'

	record /element/ var
	record /element/ me

	var.value = me.value
	var.error = me.error
	var.lower = me.lower
	var.upper = me.upper
	var.set   = .TRUE.
	var.modified = .FALSE.

	end
