	subroutine me_parse_name (line, final_index, 
     >                            order, indices, line_number)

	implicit none

	include 'db.inc'

	character*(*) line		! line to parse
	integer final_index		! index of target variable
	integer order			! order of ME
	integer indices(1)		! initial indices
	integer line_number		! line # of input file

	integer bar			! location of bar
	integer bracket			! location of bracket
	integer i			! index

	character*12 name		! variable name to check for

	integer EXTRA_VAR
	parameter (EXTRA_VAR = 11)
	character*12 name_list(EXTRA_VAR) /
     >       'x_det', 'y_det', 'theta_det', 'z', 'theta', 'phi',
     >       'drift', 
     >       'ang_slope_x', 'ang_slope_y', 'ang_offset_x', 'ang_offset_y'
     >       /

	order = -1			! invalid return code
	final_index = 1			! something by default

	if (line(1:1) .ne. '<') then
	  write (*,*) ' The first character in a matrix element name',
     >                ' must be a <'
	  if (line_number .gt. 0) write (*,*) ' Line #', line_number
	  return
	endif

	bar = index(line, '|')		! find the bar
	if (bar .eq. 0) then
	  bracket = index(line, '>')	! try for the ending bracket
	  if (bracket .ne. 0) then	! now check if I know this name
	    name = line(2:bracket-1)	! strip out the name
	    do i = 1, EXTRA_VAR
	      if (name .eq. name_list(i)) then
	        order = -1 - i
	        return
	      endif
	    enddo
	  endif
	  write (*,*) ' syntax error in matrix element name, ',
     >                  'bar (|) not found.'
	  if (line_number .gt. 0) write (*,*) ' Line #', line_number
	  return
	endif
	if (bar .le. 2) then			! nothing given
	  write (*,*) ' You must specify a final matrix',
     >                  ' element name.'
	  if (line_number .gt. 0) write (*,*) ' Line #', line_number
	endif
	call me_parse_final(line(2:bar-1), final_index, line_number)
	if (final_index .le. 0) return

	bracket = index(line, '>')		! find >
	if (bracket .eq. 0) then
	  write (*,*) ' syntax error in matrix element name, ',
     >                  'bracket (>) not found.'
	  if (line_number .gt. 0) write (*,*) ' Line #', line_number
	  return
	endif
	if (bar+1 .eq. bracket) then		! zeroth order
	  call me_parse_initial(" ", order, indices, MAX_ORDER, line_number)
	else
	  call me_parse_initial(line(bar+1:bracket-1), order, indices,
     >                          MAX_ORDER, line_number)
	endif

	end

