	subroutine me_print_me (var, order, lun, type)

	implicit none

	include 'db.inc'

	record /ofp_targ/ var(TARG_VAR)	! data to use
	integer order				! order to print out
	integer lun				! i/o unit to use
	character*(*) type			! type of ME to operate on

	integer i
	
	if (order.eq.-1) then
	   do i=-2,-12,-1
	      call print_out(i,lun)
	   enddo    
	endif

	do i = 1, TARG_VAR
	  if (order .eq. 0) then
	    call me_print_me_0(i, var(i), lun, type)
	  else if (order .eq. 1) then
	    call me_print_me_1(i, var(i), lun, type)
	  else if (order .eq. 2) then
	    call me_print_me_2(i, var(i), lun, type)
	  else if (order .eq. 3) then
	    call me_print_me_3(i, var(i), lun, type)
	  else if (order .eq. 4) then
	    call me_print_me_4(i, var(i), lun, type)
	  else if (order .eq. 5) then
	    call me_print_me_5(i, var(i), lun, type)
	  else if (order .eq. 6) then 
	    call me_print_me_6(i, var(i), lun, type)
	  endif
	enddo

	end

	subroutine me_print_me_0 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	call me_print_me0(targ_i, fpvars, var.me0, lun, type)

	end

	subroutine me_print_me_1 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	  call me_print_me_out(targ_i, fpvars, var.me1(i), lun, type)
	enddo

	end

	subroutine me_print_me_2 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i, j
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	do j = i, FP_VAR
	  fpvars(2) = j
	  call me_print_me_out(targ_i,fpvars,var.me2(i,j),lun,type)
	enddo
	enddo

	end

	subroutine me_print_me_3 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i, j, k
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	do j = i, FP_VAR
	  fpvars(2) = j
	do k = j, FP_VAR
	  fpvars(3) = k
	  call me_print_me_out(targ_i,fpvars,var.me3(i,j,k),lun,type)
	enddo
	enddo
	enddo

	end

	subroutine me_print_me_4 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i, j, k, l
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	do j = i, FP_VAR
	  fpvars(2) = j
	do k = j, FP_VAR
	  fpvars(3) = k
	do l = k, FP_VAR
	  fpvars(4) = l
	  call me_print_me_out(targ_i,fpvars,var.me4(i,j,k,l),lun,type)
	enddo
	enddo
	enddo
	enddo

	end

	subroutine me_print_me_5 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i, j, k, l, m
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	do j = i, FP_VAR
	  fpvars(2) = j
	do k = j, FP_VAR
	  fpvars(3) = k
	do l = k, FP_VAR
	  fpvars(4) = l
	do m = l, FP_VAR
	  fpvars(5) = m
	  call me_print_me_out(targ_i, fpvars,
     >                         var.me5(i,j,k,l,m), lun, type)
	enddo
	enddo
	enddo
	enddo
	enddo

	end

	subroutine me_print_me_6 (targ_i, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i
	record /ofp_targ/ var
	integer lun
	character*(*) type
	integer i, j, k, l, m, o
	integer fpvars(MAX_ORDER) /MAX_ORDER*0/

	do i = 1, FP_VAR
	  fpvars(1) = i
	do j = i, FP_VAR
	  fpvars(2) = j
	do k = j, FP_VAR
	  fpvars(3) = k
	do l = k, FP_VAR
	  fpvars(4) = l
	do m = l, FP_VAR
	  fpvars(5) = m
        do o = m, FP_VAR
          fpvars(6) = o
	  call me_print_me_out(targ_i, fpvars,
     >                         var.me6(i,j,k,l,m,o), lun, type)
	enddo
	enddo
	enddo
	enddo
	enddo
        enddo

	end

	subroutine me_print_me_out (targ_i, fpvars, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i				! target index
	integer fpvars(MAX_ORDER)		! focal plane variables
	record /element/ var
	integer lun
	character*(*) type
	character*80 string
	integer lnblnk				! returns length of non-blanks

	logical flag

	flag = .FALSE.

	if ((type .eq. 'set') .and. var.set) then
	  flag = .TRUE.
	else if ((type .eq. 'vary') .and. var.vary) then
	  flag = .TRUE.
	else if ((type .eq. 'modified') .and. var.modified) then
	  flag = .TRUE.
	else if ((type .eq. 'fixed') .and. .not. var.vary) then
	  flag = .TRUE.
	endif

	if (flag) then
	  call me_gen_name (targ_i, fpvars, string)
	  write (lun, 10) string(1:lnblnk(string)), 
     >                      var.value, var.error, 
     >                      var.lower, var.upper
10	  format (a, 4(1x,1pg17.10))
	endif

	end
	subroutine me_print_me0 (targ_i, fpvars, var, lun, type)

	implicit none

	include 'db.inc'

	integer targ_i				! target index
	integer fpvars(MAX_ORDER)		! focal plane variables
	record /element/ var
	integer lun
	character*(*) type
	character*80 string
	integer lnblnk				! returns length of non-blanks

	logical flag

    	if (targ_i.gt.1) then    
	   flag = .TRUE.
	else
	   flag = .FALSE.
	endif   

	if (flag) then
	   call me_gen_name (targ_i, fpvars, string)
	   write (lun, 10) string(1:lnblnk(string)), 
     >                      var.value, var.error, 
     >                      var.lower, var.upper
10	   format (a, 4(1x,1pg17.10))
	endif
	end
	
	subroutine print_out (i,lun)

	implicit none

	include 'db.inc'

	integer fpv(MAX_ORDER)		! focal plane variables
        real fpval,fperr,fpupp,fplow
	integer i,lun 
	character*80 string
	integer lnblnk				! returns length of non-blanks
	
	data fpv/MAX_ORDER*0/
	
	fperr = 1.0
	fpupp = 0.0
	fplow = 0.0 
	
	if (i.ne.-8) then
	   fpval = 0.0
	else
c          set the drift dist to middle of the collimator
           if ( spec_name .eq. 'hms' .or. spec_name .eq. 'HMS') then
	   fpval = 126.2+ 40.17 + 3.175/2.
           else
	   fpval = 127.8 + 3.175/2.
	   endif
	endif	

	call me_gen_name (i,fpv,string)
	write (lun, 10) string(1:lnblnk(string)), 
     >                      fpval, fperr, fplow, fpupp
     
10	format (a, 4(1x,1pg17.7))

	end
